#include <boost/test/unit_test.hpp>
#include <string.h>

BOOST_AUTO_TEST_SUITE(Index)

BOOST_AUTO_TEST_CASE(strchrIndexesForward)
{
	char *magic_string = "abracadabra";
	BOOST_CHECK_EQUAL(strchr(magic_string, 'a'), magic_string);
	BOOST_CHECK_EQUAL(strchr(magic_string, 'c'), magic_string + 4);
}

BOOST_AUTO_TEST_CASE(strrchrIndexesBackward)
{
	char *magic_string = "abracadabra";
	BOOST_CHECK_EQUAL(strchr(magic_string, 'c'), strrchr(magic_string, 'c'));
	BOOST_CHECK_EQUAL(strrchr(magic_string, 'a'), magic_string + 10);
}

BOOST_AUTO_TEST_CASE(strchrPreservesValue)
{
	char *magic_string = "abracadabra";
	BOOST_CHECK_EQUAL(*(strchr(magic_string, 'b')), 'b');
}

BOOST_AUTO_TEST_CASE(indexingFindsNullTerminator)
{
	char *magic_string = "abracadabra";
	BOOST_CHECK_EQUAL(strchr(magic_string, '\000'), magic_string + 11);
	BOOST_CHECK_EQUAL(strchr(magic_string, '\000'), strrchr(magic_string, '\000'));
}

BOOST_AUTO_TEST_CASE(NULLOnFail)
{
	char *magic_string = "abracadabra";
	BOOST_CHECK_EQUAL(strrchr(magic_string, 'z'), NULL);
	BOOST_CHECK_EQUAL(strchr(magic_string, 0xFFFFFFFF), NULL);
}

BOOST_AUTO_TEST_SUITE_END()