#ifndef CUSTOM_MMAN_H
#define CUSTOM_MMAN_H

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/types.h>

// Return value for mmap failure
#define MAP_FAILED ((void *)-1)

// mmap Protection Attributes
#define PROT_READ 0x01
#define PROT_WRITE 0x02
#define PROT_EXEC 0x04
#define PROT_NONE 0x00

// mmap Flags
#define MAP_VARIABLE 0x00 // Allowing the OS to choose the address is default...
#define MAP_FIXED 0x01
#define MAP_PRIVATE 0x02
#define MAP_SHARED 0x04
#define MAP_FILE 0x00 // Mapping a regular file is default...
// TODO: implement MAP_ANON

// msync Flags
#define MS_SYNC 0x01
#define MS_ASYNC 0x02

// Function declarations
void *mmap(void *addr, size_t length, int prot, int flags, int fd, off_t offset);
int	munmap(void *addr, size_t length);
int msync(void *addr, size_t length, int flags);
size_t getpagesize(void);

#ifdef __cplusplus
}
#endif

#endif // !CUSTOM_MMAN_H